---
title: 'Worker: message event'
slug: Web/API/Worker/message_event
tags:
  - Event
---
<div>{{APIRef}}</div>

<p>The <code>message</code> event is fired on a {{domxref('Worker')}} object when the worker's parent receives a message from its worker (i.e. when the worker sends a message using <code><a href="/en-US/docs/Web/API/DedicatedWorkerGlobalScope/postMessage">DedicatedWorkerGlobalScope.postMessage()</a></code>).</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("MessageEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td><code><a href="/en-US/docs/Web/API/Worker/onmessage">onmessage</a></code></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>This code creates a new worker and listens to messages from it using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code>:</p>

<pre class="brush: js">const worker = new Worker("static/scripts/worker.js");

worker.addEventListener('message', (event) =&gt; {
    console.log(`Received message from worker: ${event.data}`)
});</pre>

<p>Alternatively, it could listen using the <code><a href="/en-US/docs/Web/API/Worker/onmessage">onmessage</a></code> event handler property:</p>

<pre class="brush: js">const worker = new Worker("static/scripts/worker.js");

worker.onmessage = (event) =&gt; {
    console.log(`Received message from worker: ${event.data}`)
};</pre>

<p>The worker posts messages using <code><a href="/en-US/docs/Web/API/DedicatedWorkerGlobalScope/postMessage">self.postMessage()</a></code>:</p>

<pre class="brush: js">// static/scripts/worker.js

self.postMessage('I\'m alive!');</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'indices.html#event-message')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Worker.message_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: <code><a href="/docs/Web/API/Worker/messageerror_event">messageerror</a></code>.</li>
 <li><code><a href="/en-US/docs/Web/API/DedicatedWorkerGlobalScope/postMessage">DedicatedWorkerGlobalScope.postMessage()</a></code>.</li>
</ul>
